<?php
	

	// aggiungere nuovo protocollo per template


	include(ADMIN_DIR.'panels/admin.defaultpanels.php');
	require(SMARTY_DIR . 'SmartyValidate.class.php');
	
	class AdminPanel {
		
		var $panelname = null;
		var $smarty = null;
		
		var $actions = array('default');
		var $defaultaction = 'default';
		
		var $actionpanel = null;
		
		
		function AdminPanel(&$smarty) {
			$this->smarty =& $smarty;
			if (!$this->panelname)
				trigger_error("Variable \$panelname is not defined!", E_USER_WARNING);
			else $this->smarty->assign('panelname', $this->panelname);
			$this->setup();
			$this->main();
			
		}
		
		function setup() {
			// example of use:
			// $this->setActions($myactionarr = array('action1', 'action2');
			// $this->setDefaultAction($myactionarr = 'action1';
		}
		
		function &get_action($action) {
			
			$obj = null;
			
			if (!in_array($action, $this->actions)) {
				trigger_error("$action: No such an action was defined", E_USER_ERROR);
				return $obj;
			}
			
			$this->smarty->assign('actionname', $action);
			
			$class = get_class($this) . "_$action";
			
			if (!class_exists($class)) {
				
				$f = str_replace('_','.',$class);
				
				$fname = ADMIN_DIR . "panels/{$this->panelname}/$f.php";
				
			
				if (file_exists($fname)) {
					include($fname);
					
					if (!class_exists($class)) {
						trigger_error("No classes for action $action.", E_USER_ERROR);
					}
					
					$obj =& new $class($this->smarty);
					return $obj;
					
				} else trigger_error("No script found for action $action", E_USER_ERROR);
				
			} else {
				$obj =& new $class($this->smarty);
			}
		
			return $obj;
		}
		
		
		function main() {
			
			$action = null;
			
			if (isset($_GET['action'])) {
				$action = $_GET['action'];						
			} else {
				$action = $this->defaultaction;
			}

			$this->smarty->assign('success', sess_remove('success'));

			$actionPanel =& $this->get_action($action);
			if ($actionPanel) {
				$retval = $actionPanel->exec();
				
				
				if ($retval) {
					// compatibility with old panels
					// todo make panel retval == success id
					// so that we can do sess_add('success', $retval);
					sess_add('success', $this->smarty->get_template_vars('success'));
					sess_remove('fp_form_evts');
					sess_remove('last_panel');
					
					// clear postdata by a redirect
					utils_redirect("admin.php?p={$this->panelname}");
					
					
					
					//$this->smarty->assign('success', );
					//if ($actionPanel =& $this->get_action($this->defaultaction))
					//	$retval = $actionPanel->exec();
				}
				
							lang_load("admin.{$this->panelname}");
				
			}
			

			
		}
		
	}
		
	class AdminPanelAction {
		
		var $actionname = null;
		var $smarty = null;
		
		function AdminPanelAction(&$smarty) { 
			$this->smarty =& $smarty;
			
		}
		
		function exec() {

			if (!isset($_SESSION['last_panel']) ||
			    $_SESSION['last_panel'] != get_class($this)) {
				    
				unset($_SESSION['fp_form_evts']);
				$_SESSION['last_panel'] = get_class($this);
				
			}
			
			
			$this->setup();
			$result = 0; // if !=0, defaultaction for this panel is called
			
			if (empty($_POST)) {
				$result = $this->main();
			} else {
				$result = $this->onsubmit();
			}
			
			return $result;
			
			
		}
		
		function setup() {
			
		}
		
		function main() {
			return 0;
		}
		
		/**
	 	 * Method onsubmit <br />
		 *
		 * @return int values: 
		 *	1. if you want main() method to be called;
		 *	2. if you want main() method of the defaultaction
		 *	0. if you don't want any further action to be called
		 *
		 */
		
		function onsubmit() {
			//print_r(apd_callstack());
			
			$returnvalue = 1;
			
			if (isset($_SESSION['fp_form_evts'])) {
				$evts = $_SESSION['fp_form_evts'];
				$valid_evts = array_intersect(array_keys($_POST), $evts);
				
				if ($the_event=array_pop($valid_evts)) {
					$event = "on{$the_event}";
					if (method_exists($this, $event))
						$returnvalue = call_user_func(array(&$this, "on{$the_event}"));
				}
				unset($_SESSION['fp_form_evts']);
			
			}
			
			return $returnvalue;
			
		}
		
	}
	
	class AdminPanelActionValidated extends AdminPanelAction {
		
		var $validators = array();
		
		function exec() {
			
			if (!isset($_SESSION['last_panel']) ||
			    $_SESSION['last_panel'] != get_class($this)) {
				    
				unset($_SESSION['fp_form_evts']);
				$_SESSION['last_panel'] = get_class($this);
				
			}
			
			if (empty($_POST))
				SmartyValidate::disconnect($this->smarty);
			
			SmartyValidate::connect($this->smarty);
			
			$this->setup();
			
			$retval = 0;
			
			if (empty($_POST)) {
				if ($validators =& $this->validators) {
					foreach ($validators as $validator) {
						call_user_func_array(array('SmartyValidate','register_validator'),$validator);
					}
				}
				$retval = $this->main();
			} else {
				$retval = $this->onsubmit();
			}
			
			return $retval;
			
		}
		
		
		function onsubmit() {
			$result = 1;
			
			if(SmartyValidate::is_valid($_POST)) {
				$result = parent::onsubmit();
			} else $result = $this->onerror();
			
			return $result;
			
		}
		
		function onerror() {
			return true;
		}
		
		
	}
	
	class LayoutAdmin extends Abstract_LayoutDialog {
		
		var $tpl = 'admin.tpl';
	
		function main() {
			
			// general setup
			
			global $page, $subpage, $lang;
			
			$panels = admin_getpanels();
			
			lang_load('admin');
			
			if (user_loggedin()) {
				$this->page($this->lang['admin']['head'],
				null);
				$this->smarty->assign('menubar', $panels);
			} else utils_redirect("login.php?redirect=admin.php"); 
			
			function showcontrolpanel($params, &$smarty) {
				$smarty->display(ABS_PATH. ADMIN_DIR . 'main.tpl');
			}
			$this->smarty->register_function('controlpanel', 'showcontrolpanel');
			// html header
			
			function admin_title($title, $sep) {
				global $lang;
				return $title = "$title $sep {$lang['admin']['head']}"; 
			}
			
			add_filter('wp_title', 'admin_title', 10, 2);
			
			$this->smarty->append('flatpress', array('ADMIN_DIR'=>ADMIN_DIR), true);
			
			
			/************** ARGUMENT PARSING **************/
			
			// let's get the parameters and set the defaults
			// note that you can't ask for a page which is not set in the adminpanels
			// trying to do this will be considered as an hack attempt and the script
			// will therefore die()
			$page = (isset($_GET['p']))? $_GET['p'] :  key($panels);
			$this->smarty->assign('page', $page);
			$panel = "admin.$page";
			
			if (!isset($panels[$page])) 
				trigger_error('Requested panel does not exists!', E_USER_ERROR);
		
			//-------------------------------------------------------------
			
			$this->smarty->assign('panelname', $page);
			define('ADMIN_PANEL', $page);

			add_filter('wp_title', 'admin_panel_title', 10, 2);
			
			
			if (file_exists(ADMIN_DIR."panels/$page/$panel.php")) {
				include(ADMIN_DIR."panels/$page/$panel.php");
				$class = "admin_$page";
				if (class_exists($class)) {
					$this->panel = new $class($this->smarty);
				} else trigger_error("No class defined for requested panel", E_USER_ERROR);
			} else {
			
				lang_load($panel);
			
			}
			
			
			function admin_panel_title($title, $sep) {
			
				global $lang; //, $page, $subpage;
				
				$t = $lang['admin']['panels'][ADMIN_PANEL];
				
				/*if (isset($subpage)) {
					$t = $lang['admin'][$page][$subpage]['head'];
				} else {
					
				}*/
				$title = "$title $sep $t";
				return $title;
			}
			
			
			
	
		}
	
	}
	
	$FLATPRESS =& new LayoutAdmin;
	$FLATPRESS->display();
	

	
?>
