<?php

/**
 * edit entry panel
 *
 * Type:     
 * Name:     
 * Date:     
 * Purpose:  
 * Input:
 *         
 * @author NoWhereMan <real_nowhereman at users dot sf dot com>
 *
 */
 	
	
 

 	class admin_entry_write extends AdminPanelActionValidated {
		
		var $validators = array(
				array('subject', 'subject', 'notEmpty', false, false, 'trim,stripslashes'),
				array('content', 'content', 'notEmpty', false, false, 'stripslashes'),
			); 
		
		function _makePreview($arr, $id=null) {
			
			$arr['subject'] = apply_filters('title_save_pre', $arr['subject']);
			$arr['content'] = apply_filters('content_save_pre', $arr['content']);
			
			
			$this->smarty->assign('post', $arr);
			
			if (THEME_LEGACY_MODE) {
				theme_entry_filters($arr, $id);
			}
			
			$arr = array_change_key_case($arr, CASE_LOWER);
			
			$this->smarty->assign('entry', $arr);
			$this->smarty->assign('preview', true);
			
		}
 	
		function makePageTitle($title, $sep) {
			global $lang;
			return "$title $sep {$lang['admin']['entry']['publish']['head']}";
		}
	
		function _getCatsFlags() {
				
			//$this->smarty->assign('saved_categories', entry_categories_format());
			$this->smarty->assign('saved_flags', entry_flags_get());
			
		}
		
		function main() {
			
			global $lang;
			
			if (isset($_GET['entry'])) {
				$id = $_GET['entry'];
				$arr = entry_parse($id);
				// if entry does not exists
				if ($arr) {
					$this->_makePreview($arr, $id);		
				} 
		
			}
			
			$this->_getCatsFlags();
			add_filter('wp_title', array(&$this, 'makePageTitle'), 10, 2);
				
		}
		
		function _getposteddata() {

			$arr['version'] = system_ver();
			$arr['subject'] = ($_POST['subject']);
			$arr['content'] = ($_POST['content']);
			$author = user_get();
			$arr['author'] = $author['NAME'];
			$arr['date'] = !empty($_POST['timestamp'])?$_POST['timestamp']:time();
			
			$cats = !empty($_POST['cats'])?$_POST['cats']:array();
			$flags = !empty($_POST['flags'])?$_POST['flags']:array();
			
			$catids = array_merge(array_keys($flags), array_keys($cats));
			
			if ($catids)
				$arr['categories'] = $catids;
			
			return $arr;
		
		}
		
		function onsave() {
			
			$id = isset($_REQUEST['entry'])? $_REQUEST['entry'] : null;
			$success=entry_save($this->_getposteddata(), $id);
	
			if ($success) sess_remove('entry');
			
			$this->smarty->assign('success',$success? 1:-1);
			
			return 1;
		}
		
		
		function onpreview() {
			global $lang;
			
			$this->_makePreview($this->_getposteddata());		
			
			
			$this->_getCatsFlags();
			//add_filter('wp_title', $this->_makePageTitle($lang['admin']['entry']['publish']['head']), 10, 2);
			add_filter('wp_title', array(&$this, 'makePageTitle'), 10, 2);
			
			return 0;
			
			
		}
		
		function onsavecontinue() {
			global $lang;
			
			$arr = $this->_getposteddata();
			
			if (!isset($arr['categories']) || !array_intersect(array('draft'), $arr['categories']))
				$arr['categories'][] = 'draft';
			
			
			$this->_makePreview($arr);
			
			$id = isset($_REQUEST['entry'])? $_REQUEST['entry'] : null;
			$success=entry_save($arr, $id);
			
			//$panelmsgs =& $lang['admin']['entry']['msgs'];
			
			$this->smarty->assign('success', $success? 1 : -1);
			
			
			$this->_getCatsFlags();
			//add_filter('wp_title', $this->_makePageTitle($lang['admin']['entry']['publish']['head']), 10, 2);
			add_filter('wp_title', array(&$this, 'makePageTitle'), 10, 2);
			
			return 0;
			
		}
		
		
		function onerror() {
			$this->main();
			return 0;	
		}

	}

?>
