<?php

	require_once 'defaults.php';
	require_once (INCLUDES_DIR.'includes.php');
	require SMARTY_DIR . 'SmartyValidate.class.php';
	
	class LayoutComment extends Abstract_LayoutComment {
		
		
		var $tempquery = array();
		
		// Class main method.
		
		function main() {
			if (isset($_GET['entry'])) {
				// if comments.php?entry=XXXXXX equals a valid entry id 
				$id = $_GET['entry'];
				if (utils_validateinput($id)) 
				{
					
					
					$this->fpdb->query("id:$id,fullparse:true,comments:true");
					
					// hackish solution to get title before fullparse starts dunno, I don't like it					
					$this->fpdb->doquery(0);
					$this->tempquery = $this->fpdb->getEntry(0);
					
					// if comments are locked the helper method commentform()
					// is not called. This way we should prevent any backdoor
					// attack which could override the comment lockdown
					
					if (!in_array('commslock', $this->tempquery[1]['categories'])) {
						
							$this->commentform();
					}
					
					// we add to the wp_title the method $this->permatitile()
					add_filter('wp_title', array(&$this, 'permatitle'), 10, 2);
			
							
				}
		
			} else {
				// given parameter is not valid. redirect the user
				// to home
				utils_redirect();
			}
		}
		
		function generate_id($str){
			$myfields=array();
			foreach($str as $field) {
				$id = dechex(crc32($field . $this->config['BLOGID'])*mt_rand());
				$myfields[$field]="fp$id";	
			}
			sess_add('fields', $myfields);
			return $myfields;
			
		}
		
		
		// this method is added by commentform() to the page header hook
		// this way it will do output when the page is loading
		
		function permatitle($title, $sep) {
			global $lang, $page, $subpage;
			
			//this->fpdb->query($this->params);
			$t = $this->tempquery[1]['subject'];
			
			return  "$title $sep $t";
			
		}
			
		
		function comment_validate() {

			
			$arr['version'] = system_ver();
			$arr['name'] = $_POST['name'];
			
			if (user_loggedin()) {
				$arr['loggedin']=true;
			}
			
			
			if (!empty($_POST['email']))
				($arr['email'] = $_POST['email']);
			if (!empty($_POST['url']))
				($arr['url'] = $_POST['url']);
			$arr['content'] = $_POST['content'];
			
			$arr['ip-address'] = utils_ipget();
			
			if (apply_filters('comment_validate', true, $arr))
				return $arr;
			else return false;
					
			
		}
		
		function commentform() {
			
			$smarty =& $this->smarty;
			$lang =& $this->lang;
			
			//$fields = $this->generate_id(array('name', 'email', 'url', 'content'));
			//$this->smarty->assign('fields', $fields);
			
			if (isset($_GET['success']) && $_GET['success'])
				$smarty->assign('error',array($lang['comments']['success']));


			if(empty($_POST)) {
			// new form, we (re)set the session data
				SmartyValidate::connect($smarty, true);
				//SmartyValidate::register_form('fp-comments');
			// register our validators
					
					SmartyValidate::register_validator('name', 'name', 'notEmpty', false, false, 'trim,stripslashes');
					SmartyValidate::register_validator('email','email', 'isEmail', true, false, 'trim,stripslashes');
					SmartyValidate::register_validator('www', 'url', 'isURL', true, false, 'trim,stripslashes');
					SmartyValidate::register_validator('comment', 'content', 'notEmpty', false, false, 'stripslashes');
				
			} else {    
				// validate after a POST
				SmartyValidate::connect($smarty);
				//$fields = sess_get('fields');
	
				if (!empty($_POST['url']) && strpos($_POST['url'], 'http://')===false) $_POST['url'] = 'http://'.$_POST['url'];
				
				
				// custom hook here!!
				if( SmartyValidate::is_valid($_POST) && ($arr=$this->comment_validate())) {
					//SmartyValidate::disconnect();
					
					
					$id = comment_save($_GET['entry'], $arr);
					
					do_action('comment_post', $_GET['entry'], array($id, $arr));
					
					$comm_mail = isset($arr['email'])? "<{$arr['email']}>" : '';
					
					if ($this->config['NOTIFY'] && !user_loggedin()) {

						// this is temporarily here; it will be moved to lang soon	
						$mail = 
						<<<MSG
Dear {$this->config['AUTHOR']},

"{$arr['name']}" {$comm_mail} has just posted a comment to the entry entitled "{$this->tempquery[1]['subject']}".

This is the commentlink to your entry:
{$this->config['WWW']}comments.php?entry={$_GET['entry']}#$id

Here is the comment that has just been posted:
***************
{$arr['content']}
***************

All the best,
{$this->config['TITLE']}


MSG;
						// $addr = isset($arr['email'])? $arr['email'] : 
						utils_mail($this->config['EMAIL'], "New comment on {$this->config['WWW']}", 
							$mail);
							
					}
					
					// if comment is valid, this redirect will clean the postdata
					utils_redirect("comments.php?entry={$_GET['entry']}#$id");
					//utils_redirect($_SERVER['REQUEST_URI']."&success=true#$id", false);
				} else {
					$smarty->assign('values', $_POST);
				}
			}
		}

		
		
		
	
	}

	$FLATPRESS =& new LayoutComment;
	$FLATPRESS->display();
	
	// At the end every script does this:
	//require_once 'finalize.php';
	
?>
