<?php


	function lang_load($postfix=null) {
		global $lang, $blog_config;
		
		$plugin = false;
		$pluginpath='';
		
		// checks if we already loaded this lang file
		$vals = explode('.', $postfix); // my.file.name ---> my, file, name
		$arr =& $lang;
		
		// performs recursive search of the nested keys "my, file, name"
		// same result of
		// isset($lang['my']['file']['name'])
		$noload = false;
		$v = null;
		while($v = array_shift($vals) && $doload = isset($arr[$v])) 
			{ $arr =& $arr[$v]; } 
		
		if ($noload) // keys are already loaded. return 
			return $lang;
		
		if ($postfix) {
			
			if (strpos($postfix, 'plugin:')===0) {
				$pluginpath = substr($postfix, 7);
			}
			
			$file = "lang.$postfix.php";
			
		} else {
		
			$postfix='default';
			$file = "lang.default.php";
			
		}
		
		$fpath=LANG_DIR."{$blog_config['LANG']}/$file";
		$fallback=LANG_DIR.LANG_DEFAULT."/$file";
		
		
		$path = '';
		$plugin=$pluginpath;
		
		
		if ($pluginpath) {
			if (($n = strpos($pluginpath, '/'))!==false) {
				$plugin = substr($plugin, 0, $n-1);
				$path = substr($plugin, $n+1);
				$path = str_replace('/', '.', $path);
			}
			
			$dir = plugin_getdir($plugin);
			 
			$fpath    = $dir . "lang/lang.{$blog_config['LANG']}{$path}.php";
			$fallback = $dir . "lang/lang.".LANG_DEFAULT."{$path}.php";
			
		}			

	     	if (file_exists($fpath)) {
		     	include ($fpath);
			return $lang;
		} elseif (file_exists($fallback)) {
			include($fallback);
			return $lang;
		} else {
			trigger_error("No suitable language file was found <b>$postfix</b>", E_USER_WARNING);
		}
	}
	
	function lang_getconf($id) {
		global $lang, $blog_config;
		$fpath=LANG_DIR."$id/lang.conf.php";
	     	if (file_exists($fpath)) {
		     	include ($fpath);
			return $langconf;
		} else
			trigger_error("Error loading config for language \"$file\"", E_USER_WARNING);
	}



	class lang_indexer extends fs_filelister {
		
		var $_directory=LANG_DIR;
		
		function _checkFile($directory, $file) {
			
			if (is_dir("$directory/$file")) {
				$this->_list[$file] = lang_getconf($file);
			}
			
			return 0;
			
		}
		
	}
	
	function lang_list() {
		$obj =& new lang_indexer();
		return $obj->getList();
	}
	
	
?>
