<?php

	//define('PLUG_BLOCK', 'block');

	
	class plugin_indexer extends fs_filelister {
		
		var $_varname = 'fp_plugins';
		var $_enabledlist = null;
		var $_directory = PLUGINS_DIR;
		
		function plugin_indexer() {
			$this->_enabledlist = CONFIG_DIR . 'plugins.conf.php';
		}
		
		function _checkFile($directory, $file) {
			$f = "$directory/$file";
			if (is_dir($f)) {
				array_push($this->_list, $file);
			}
			return 0;
		}
		
		/*
		 *
		 * @param $checkonly bool 	if false will load all the plugins, 
		 *				if true will check if the plugin exist 
		 */
		
		function getEnableds($checkonly) {
		
			$lang =& $GLOBALS['lang'];
			$errors = array();
		
			if (!file_exists($this->_enabledlist))
				return false;
			include($this->_enabledlist);
			$var = $this->_varname;
			
			foreach ($$var as $plugin) {
				
				$errno = 0;
				
				if (file_exists($f = PLUGINS_DIR . "$plugin/plugin.$plugin.php")){
					$errno = 1; // 1 means exists
				}elseif (file_exists($f = PLUGINS_DIR . "$plugin/$plugin.php")){
					$errno = 2; // 2 means exists but filename is oldstyle
				} 
				
				
					
				include_once($f);
				$func = "plugin_{$plugin}_setup";
				if (is_callable($func)){
					$errno = $func();
				}
				
				if ($checkonly) {
					if ($errno<=0) {
					
						@lang_load("plugin:{$plugin}");
						
						if (isset($lang['plugin'][$plugin]['errors'][$errno])) {
							$errors[] = "[<strong>{$plugin}</strong>] {$lang['plugin'][$plugin]['errors'][$errno]}";
						} else {
							$errors[] = "[<strong>$plugin</strong>] " . 
							sprintf($lang['admin']['plugin']['errors']['generic'], $errno);
						}
						
					}
				}
				
			}
			
			return $errors;
			
		}
		
	}
	
	function plugin_loadall($check=false){
		
		// this is done during init process
		// all the plugin are loaded
		
		$pluginlister =& new plugin_indexer;
		return $pluginlister->getEnableds($check);
	}

	function plugin_get($id=null){
	
		$pluginlister =& new plugin_lister;
		$pluginlister->getList();
		
	}
	
	function plugin_loaded($id) {
		
		if (file_exists(PLUGINS_DIR . $id. '/plugin.'. $id.".php")) {
			return true;
		} 
		
		return false;
	}


	function plugin_do($id, $type=null){
		$entry = null;
		if (file_exists($f = PLUGINS_DIR . 'plugin.'. $id.".php")) {
			include_once($f);
		} else return false;
	}
	
	function plugin_require($id) {
	
		return !plugin_loaded($id);
			/*
			global $_FP_SMARTY;
			$_FP_SMARTY->trigger_error("A plugin required <strong>$id</strong> to be loaded to work properly, but $id ".
			"does not appear to be loaded. Maybe the plugins have been loaded in the wrong sequence. ".
			"Check your <a href=\"admin.php?p=plugins\">plugin config</a> in the control panel");
			*/
			
	}
	
	function plugin_getdir($id) {
		return PLUGINS_DIR . $id . '/';
	}
	
	function plugin_geturl($id) {
		return BLOG_BASEURL . PLUGINS_DIR . $id . '/';
	}
	
	function smarty_function_plugin_getdir($params, &$smarty) {
		if (!isset($params['plugin'])) //todo complete here
			$smarty->trigger_error('You must set plugin= parameter to a valid id!'); 
		return plugin_getdir($id);
	}
	
	$_FP_SMARTY->register_function('plugin_getdir','smarty_function_plugin_getdir');


?>
