<?php 

	/**
	 * system.php
	 * string-to-php and general system functions 
	 */
	
	
	

	/**
	 * function system_save
	 * 
	 * This function saves a list of variables provided after $file
	 * encapsulated in an array where KEY is the var name
	 * in a php file.
	 *
	 * Example usage:
	 * <code>
	 * <?php
	 * // Let's suppose you want to save an array called $my_arr
	 *  // in file $my_file
	 * $my_file = 'path/to/file'
	 * $my_arr = array ('val1', 'val2', 'val3');
	 * $save_arr = array('$my_arr' => $my_arr); //same as: $save_arr['$my_arr'] = $my_arr);
	 * system_save($my_file, $my_arr);
	 * // now the file $my_file will contain the following lines:
	 *  // global $my_arr;
	 * // $my_arr = array (
	 * //           '$my_arr' => val1', 
	 * //           '$my_arr' => 'val2', 
	 * //           '$my_arr' => 'val3'
	 * //           );
	 * ?>
	 * </code>
	 *
	 * @param string $file file path where $array contents will be saved
	 * @array $var_list list of vars to be saved
	 * @return bool
	 *
	 * @see config_save, config_load
	 *
	 */
	function system_save($file, $array ) {
		
		//if ( ( $numargs = func_num_args() ) > 1) {
		
			$string = "<?php\n\n";
		
			//$arg_list = func_get_args();
			foreach ($array as $key => $arg) {
				//$vname = utils_vname ($arg);
				//var_export($arg);
				$s = /*"  global {$key};\n*/  "\${$key} = " .
						var_export($arg, true) . ";\n";
				$string .= $s;
			}
		
			$string .= "\n?>";
			
			return io_write_file($file, $string);
		
		//} else die('Wrong number of parameters!');
			
	}
	
	define('SYSTEM_VER', '0.703.2');
	function system_ver() {
		return 'fp-' . SYSTEM_VER;
	}
	
	function system_generate_id($string) {
		return 'fp-'.dechex(crc32($string) ^ mt_rand());
	}
	
	function system_guessblogroot() {
		return substr($_SERVER['REQUEST_URI'],	0,strrpos($_SERVER['REQUEST_URI'],'/')+1);
	}
	
	function system_guessbaseurl() {
		return 'http://'.$_SERVER['HTTP_HOST']. BLOG_ROOT;
	}
	
	function system_getindex() {
		if (MOD_BLOG != INDEX)
			return MOD_BLOG;
		else
			return 'index.php'; 
	}
	

?>