<?php
	
	function theme_loadsettings() {
		
		global $blog_config, $theme, $FLATPRESS;
		
		$theme = array(
			// name of the theme
			'name' 			=> 'theme',
			// author of the theme
			'author' 		=> 'anonymous',
			// theme website
			'www' 			=> 'http://flatpress.nowhereland.it',
			// fp version
			'version'		=> -1,
			// default style (must be in res/ dir
			'style_def' 		=> 'style.css',
			// default style for admin panel (usually it's the same of the theme)
			'style_admin' 		=> 'style.css',
			// if false a default css is used to style some elements of the panel
			// if true, we'll suppose these elements are already styled in your own css's
			'admin_custom_interf'	=> false
		);
		
		if (!defined('THE_THEME'))
			define('THE_THEME', $blog_config['THEME']);
			
		// backward compatibility:
		$conf1 = THEMES_DIR . THE_THEME . '/theme_conf.php';
		
		// new naming convention. Yeah, I know, just an underscore
		// instead of the dot, so? It is more "consistent" :D
		$conf2 = THEMES_DIR . THE_THEME . '/theme.conf.php';
		
		if (file_exists($conf2)) {
			include($conf2);
		} elseif (file_exists($conf1)) {
			include($conf1);
		}
		
		if (!defined('THEME_LEGACY_MODE')) {
			if ($theme['version'] < 0.702) {
				define('THEME_LEGACY_MODE', true);
			} else {
				define('THEME_LEGACY_MODE', false);
			}
		}
				
		return $theme;
		
	}
	
	

	function theme_id($theme) {
		 $filename = THEMES_DIR . $theme . '/id';
		 $handle = fopen($filename, "r");
		 $contents = fread($handle, filesize($filename));
		 fclose($handle);
		 return $contents;

	}

 
	function theme_list() {
		$dir = THEMES_DIR;
		$dh  = opendir($dir);
		$i = 0;
		while (false !== ($filename = readdir($dh))) {
			if ( ($filename != '.') && ($filename != '..') ) {
				$files[$i++] = $filename;
			}
		}
		sort($files);
		return $files;
	}
	
     
	function theme_wp_head() {
		global $blog_config;
		
		echo "\n<!-- FP STD HEADER -->\n";
		
		// echo "\n<link media=\"screen\" href=\"interface/templates/form.css\" type=\"text/css\" rel=\"stylesheet\" />";
		
		echo "\n<meta name=\"generator\" content=\"FlatPress ". system_ver() ."\" />\n";
		//echo "<link rel=\"alternate\" type=\"application/rss+xml\" title=\"Get RSS 2.0 Feed\" href=\"{$blog_config['www']}rss.php\" />\n";
		echo "<link rel=\"alternate\" type=\"application/rss+xml\" title=\"Get RSS 2.0 Feed\" href=\"" . BLOG_BASEURL . MOD_RSSFEED . "\" />\n";
	
		echo "<!-- EOF FP STD HEADER -->\n";
	}
	
	function theme_head_stylesheet() {
		
		global $blog_config, $theme;
		
		echo "\n<!-- FP STD STYLESHEET -->\n";
		
		echo '<link media="screen" href="';
		echo BLOG_BASEURL . THEMES_DIR . THE_THEME;
		
		
		$css = class_exists('adminpanel')?
			 $theme['style_admin'] : $theme['style_def'];
		 
		echo '/res/' . $css .'" type="text/css" rel="stylesheet" />';
		
		echo "\n<!-- FP STD STYLESHEET -->\n";
		

	}

	function admin_head_action() {
		global $theme;
		if (!$theme['admin_custom_interface'])
			echo '<link media="screen" href="admin/res/admin.css" type="text/css" rel="stylesheet" />';
	}
		
	add_filter('admin_head', 'admin_head_action');



	
	add_action('wp_head', 'theme_wp_head');
	add_action('wp_head', 'theme_head_stylesheet');


	
	
		function get_wp_head() {
			do_action('wp_head');
			if (class_exists('AdminPanel'))
				do_action('admin_head');
		}
		
		$_FP_SMARTY->register_function('header', 'get_wp_head');
		
	
	function theme_wp_footer() {
		global $blog_config;
		echo $blog_config['FOOTER'];
	}
	
	add_action('wp_footer', 'theme_wp_footer');	
	
		function get_wp_footer() {
			do_action('wp_footer');
		}
		
		$_FP_SMARTY->register_function('footer', 'get_wp_footer');
	
	
	function theme_charset() {
		global $blog_config;
		header('Content-Type: text/html; charset='. $blog_config['CHARSET']);
		
	}
			
	add_action('init', 'theme_charset');
	
	function theme_init(&$smarty, &$mode) {
		
		global $blog_config;
		global $lang;
		global $theme;
		
		// avoid compiled tpl collision (i.e. change theme without this and cry)
		$smarty->compile_id = md5($blog_config['THEME']);
		$smarty->template_dir = THEMES_DIR . $blog_config['THEME'] . '/';
		
		$loggedin = user_loggedin();
		
		$flatpress = $blog_config;
		// retained for compatibility 
		// todo: ugly, clean this up
		// smarty has constant facilities included ^_^
		//$flatpress['FP_INTERFACE']	= FP_INTERFACE;
		//$flatpress['BLOGURL']	= BLOG_BASEURL;
		
		
		$flatpress['loggedin']	= $loggedin;
		
		if ($loggedin)
			$flatpress['user'] = user_get();
		
		// useful shorthand for themes
		// e.g. {$flatpress.themeurl}/imgs/myimage.png
		
		$flatpress['themeurl'] = BLOG_BASEURL . THEMES_DIR .  $flatpress['THEME'];
			
		$smarty->assign('flatpress', $flatpress);
		
		$smarty->assign('lang', $lang);
		
		$smarty->assign('blogtitle', $blog_config['TITLE']);

		$smarty->assign('pagetitle', 
				apply_filters('wp_title', "", '&raquo;'));
				
		
		$smarty->register_modifier('tag', 'theme_apply_filters_wrapper');
		$smarty->register_modifier('link', 'theme_apply_filters_link_wrapper');
		$smarty->register_modifier('filed', 'theme_entry_categories');
		
		$smarty->register_function('action', 'theme_smarty_function_action');
		
		
	}
	
	function theme_apply_filters_wrapper($var, $hook) {
		return apply_filters($hook, $var);
	}
	
	
	function theme_apply_filters_link_wrapper($var, $hook) {
		return apply_filters($hook, '', $var);
	}
	
	
	
	function theme_smarty_function_action($params, &$smarty) {
		if (isset($params['hook']))
			do_action($params['hook']);
			
	}
	
	
	
	// {{{ permalink, commentlink, staticlink:  filters
	 
	add_filter('post_link', 'theme_def_permalink', 0, 2);
	function theme_def_permalink($str, $id) {
		return system_getindex() . "?entry=$id";
	}
	function theme_permalink ($id) {
		return apply_filters('post_link', '', $id);
	}
	
	add_filter('comments_link', 'theme_def_commentlink', 0, 2);
	function theme_def_commentlink($str, $id) {
		return MOD_COMMENTS . "?entry=$id";
	}
	function theme_commentlink ($id) {
		return apply_filters('comments_link', '', $id);
	}
	

	add_filter('page_link', 'theme_def_staticlink', 0, 2);
	function theme_def_staticlink($str, $id) {
		return MOD_STATIC . "?page=$id";
	}
	function theme_staticlink ($id) {
		return apply_filters('page_link', '', $id);
	}
	
	
	// }}}
	
	
	function theme_entry_commentcount($count) {
		global $lang;
		switch ($count) {  
			case 0: 	return $comments = $lang['main']['nocomments'];
			case 1:		return $comments = $lang['main']['comment'];
			default:	return $comments = $count . ' ' . $lang['main']['comments'];
		}
		
	}
	add_filter('comments_number', 'theme_entry_commentcount');
	
	
	function theme_entry_categories($cats, $link = true, $separator=', ') {
		if (!$cats) {
			return;
		} else {
			$filed=array();
			if ($tmp1 = entry_categories_get('defs')) {
				
				foreach ($tmp1 as $k=>$c) {
					if(array_intersect(array($k),$cats)) {  
						$filed[] = $link? "<a href=\"index.php?cat=$k\">$c</a>" : $c;
					}
				}
			}
			if ($filed) {
				return implode($separator, $filed);
			}
		}
	}
	
	/*
		this is called only in legacy mode
		
	*/
	
	
	// {{{ ENTRY
	function &theme_entry_filters(&$contentarr, $id=null) {
		
		$contentarr['subject']=apply_filters('the_title', $contentarr['subject']);
	
		$contentarr['content'] = apply_filters('the_content', $contentarr['content']);
		
		if (isset($contentarr['comments'])) {
			$contentarr['commentcount'] = $contentarr['comments'];
			$contentarr['comments'] = apply_filters('comments_number', $contentarr['commentcount']);
		}
		
			
		$contentarr['permalink']=theme_permalink($id);
		
		$contentarr['commentlink']=theme_commentlink($id);
		
		return $contentarr;
	}
	
	//{{{ COMMENTS	
	function &theme_comments_filters(&$contentarr, $key) {
		
		$contentarr['name']=apply_filters('comment_author_name', $contentarr['name']);
		if (isset($contentarr['email'])) {
			$contentarr['email']=apply_filters('comment_author_email', $contentarr['email']);
			$contentarr['mailto'] = 'mailto:' . $contentarr['email'];
		}
		if (!isset($contentarr['url'])) $contentarr['url'] = '#'; 
		$contentarr['timestamp']=$contentarr['date'];
		$contentarr['content']=apply_filters('comment_text', $contentarr['content']);
		
		return $contentarr;

	}
		
	
?>
