<?php	

	/**
	 * Block-Managing Functions
	 */
	 
	 
	 
	class widget_indexer extends fs_filelister {
		
		var $_varname = 'fp_widgets';
		var $_enabledlist = null;
		
		function widget_indexer() {
			if (!file_exists(CONFIG_DIR. 'widgets.conf.php')) 
				trigger_error('widgets.conf.php not found. Blog may not work as expected, create a widgetlist.conf.php 
					or reinstall completely FlatPress. If you have just installed FlatPress, the package you
					downloaded may be corrupted.', E_USER_WARNING);
			$this->_enabledlist = CONFIG_DIR . 'widgets.conf.php';
			$this->getEnableds();
		}

		function getEnableds() {
			
			if (!file_exists($this->_enabledlist))
				return;
			
			include($this->_enabledlist);
			
			$this->_list = ${$this->_varname};
			
		}
		
		function hasMore($hor) {

			return is_array($this->_list[$hor]) &&  (current($this->_list[$hor]) !== false);
		}
		
		function checkAll() {
		
			if (!($this->_list)) return array();
					
		
			global $lang;
			$errs = array();
			
			foreach ($this->_list as $pos => $group) {
				if (is_array($group)) {
					foreach ($group as $id) {
						list($newid) = explode(":", $id);
						$var = 'plugin_' . $newid . '_widget';
						if (!function_exists($var)) {
							$errs = sprintf($lang['admin']['widgets']['errors']['generic'], $newid);
						}			
					}
				}
			}
			
			return $errs;
				
		}
		
		function get($hor) {
		
			$content = array();
		
			do {
				list(,$id) = each($this->_list[$hor]);
				
				list($newid, $params) = explode(":", $id);
				if ($params) $params = explode(',', $params); else $params = array();
				$var = 'plugin_' . $newid . '_widget';
				if (function_exists($var)) {
					$content = call_user_func_array($var, $params); 
					if (!isset($content['id'])) {
						$content['id'] = "widget-$newid";
					}
				} /*
					else $content = array(
					'subject' => "Sidebar::Error", 
					'content' => "<ul class=\"widget-error\"><li>No $var function found for plugin $newid. 
					Plugin may not have been loaded. 
					Verify whether it is enabled.</li></ul>",
					);
					*/
				
			} while(!$content);
				
				return array_change_key_case($content, CASE_LOWER);
				
			
			
			
		}

	}
	
	function widgets_checkall() {
		global $fp_widgets;
		return $fp_widgets->checkAll();
	}	

	function smarty_block_widgets($params, $content, &$smarty, &$repeat) {
		global $fp_widgets;
		
		if($repeat = $fp_widgets->hasMore(($params['pos']))) {
			
			$entry = $fp_widgets->get(($params['pos']));
			$smarty->assign($entry);
		}

		return $content;
		
	}		
	
	
	$_FP_SMARTY->register_block('widgets','smarty_block_widgets');
	
	

?>
