<?php

	// Example of use
	require_once 'defaults.php';
	require_once (INCLUDES_DIR.'includes.php');
	
	require(SMARTY_DIR . 'SmartyValidate.class.php');
		
	
	class rawsearchbot extends fs_filelister {
		
		var $_varname = 'cache';
		var $_cachefile = null;
		var $_directory = CONTENT_DIR;
		var $_constrained_list = array();
		
		function rawsearchbot($keywords, $fullparse, $searchjusthese=array()) {
			
			$this->keywords = strtolower($keywords);
			$this->fullparse = $fullparse;
			$o = new entry_indexer;
			$this->entry_arr = $o->getList();
			
			
			if ($searchjusthese) {
				$this->_constrained_list = $searchjusthese;
			}
			return parent::fs_filelister();
			
		}
		
		function _checkFile($directory, $file) {
			
			$f = "$directory/$file";
			
			if ( is_dir($f) && ctype_digit($file)) {
					return 1;
			}
			
			if (fnmatch('entry*'.EXT, $file)) {
				$id=basename($file,EXT);
				$arr = $this->entry_arr[$id];
				
				if (in_array('draft',$arr['categories'])) return 0;
				
				if ($this->fullparse) {
					$str = strtolower(io_load_file(bdb_idtofile($id, BDB_ENTRY)));
					
					if (strpos($str, $this->keywords)!==false) {
						$this->_list[$id] = $arr['subject'];
					}
					
				} else {
					if (strpos(strtolower($arr['subject']), $this->keywords)!==false) {
						$this->_list[$id] = $arr['subject'];
					}
				}
				return 0;
			}
		}
		
	}
	
	
	class LayoutDialogSearch extends Abstract_LayoutDialog {
		
		var $tpl = 'default.tpl';
		
		function main() {
			
			global $lang;
			
			if(empty($_GET)) {
				// display form
				$title = $this->lang['search']['head'];
				$content = "shared:search.tpl"; 
			} else {    
				// validate
				if(isset($_GET['keywords']) && $kw = trim($_GET['keywords'])) {
					$title = $this->lang['search']['head'];
					$content = "shared:search_results.tpl"; 
					
					
					
					$o =& new rawsearchbot(
							$kw, 
							(isset($_GET['stype']) && $_GET['stype']=='full')
						);
					$this->smarty->assign('searchresults', $o->getList());
					
					
					
				} else {
					$this->smarty->assign('error', $lang['search']['error']['keywords']);
					$title = $this->lang['search']['headres'];
					$content = "shared:search.tpl"; 
					
				}
			}
			
			// Set page title and content
			// first parameter is Title, second is content.
			// Content can be both a shared tpl or raw html content; in this last case
			// you have to set the third optional parameter to true

			$this->page($title, $content);

		}
		
		/*
		function dbsearch() //slooooooowwwww {
			
			// get parameters
						
					$params = array();
					$params['start']=0;
					$params['count']=-1;
					
					($_GET['Date_Day']) && ($_GET['Date_Day']!='--')? $params['d'] = $_GET['Date_Day']: null;
					isset($_GET['Date_Month']) && ($_GET['Date_Month']!='--')? $params['m'] = $_GET['Date_Month'] : null;
					($_GET['Date_Year']) && ($_GET['Date_Year']!='--')? $params['y'] = substr($_GET['Date_Year'], 2) : null;
					
					isset($_GET['cats'])? $params = $_GET['cats']: null;
					
					
					if ($_GET['stype']=='titles') {
						
						$params['fullparse'] = 'false';
						
					}elseif($_GET['stype']=='full') {
						
						$params['fullparse'] = 'true';
						
					}
					
					
					$params['callback'] = array(&$this, 'search_keywords');
					
					$this->fpdb->query($params);
					//$this->fpdb->doquery();
					
					//$this->keywords = explode(' ',strtolower($_GET['keywords']));
					$this->keywords = strtolower($_GET['keywords']);
		
		}
		
		
		function search_keywords($entry) {
		
			list($id, $contentarr) = $entry;
			return strpos(strtolower($contentarr['subject']), $this->keywords)!==false;
			
			
		}
		
		*/
	}
	
	$FLATPRESS =& new LayoutDialogSearch;
	
	
	function srch_title($title, $sep) {
		global $lang;
		return $title = " &raquo; {$lang['search']['head']}";
	}
	
	add_filter('wp_title', 'srch_title', 10, 2);
	
	
	$FLATPRESS->display();
	
?>