<?php 


function print_done_fail($label, $bool) {
	echo
	"<li>", 
	$label.' <strong style="color :' . 
	(($bool)? 'green;">DONE' : 'red;">FAILED') .
	'</strong><br />',
	"</li>\n";
}

function config_exist() {
	return file_exists(CONFIG_DIR);
}

function cache_exist() {
	return file_exists(CACHE_FILE);
}


function validate_old() {
	
	// step one and two have been merged
	
	global $blog_config;
	

	if (!(preg_match('!@.*@|\.\.|\,|\;!', $_POST['email']) ||
			preg_match('!^.+\@(\[?)[a-zA-Z0-9\.\-]+\.([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$!', $_POST['email']))) {
		$err[1] = "{$_POST['email']} is not a valid email address";
	} else {
		$blog_config['EMAIL'] = $_POST['email'];
	}
		
	if (isset($err)) {
		$GLOBALS['err']=$err;
		return 1;
	}
	
	
	$blog_config['BLOGID']=system_generate_id(BLOG_ROOT.$blog_config['WWW'].$blog_config['EMAIL'].$blog_config['AUTHOR'] );
		
	//$oldarr = sess_remove('step1');
	config_save($blog_config);
	
	return 0;
		
}

function validate() {
	if (!ctype_alnum($_POST['fpuser']))
		$err[] = "{$_POST['fpuser']} is not a valid username. 
		Username must be alphanumeric and should not contain spaces.";
	
	if (strlen(trim(($_POST['fppwd']))) < 6)
		$err[] = "Password must contain at least 6 non-space characters";
	
	if (($_POST['fppwd'])!=($_POST['fppwd2']))
		$err[] = "Passwords did not match"; 
	
	if (!(preg_match('!@.*@|\.\.|\,|\;!', $_POST['email']) ||
			preg_match('!^.+\@(\[?)[a-zA-Z0-9\.\-]+\.([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$!', $_POST['email'])))
		$err[] = "{$_POST['email']} is not a valid email address";
	
	$www = $_POST['www'];
	if (!(preg_match('!^http(s)?://[\w-]+\.[\w-]+(\S+)?$!i', $www)
    		|| preg_match('!^http(s)?://localhost!', $www)))
			$err[] = "$www is not a valid URL";
	if ($www[strlen($www)-1]!='/')
		$www .= '/';
	
	global $blog_config;
		
	$blog_config['AUTHOR'] = $user['NAME'] = $_POST['fpuser'];
	$user['PWD'] = $_POST['fppwd'];
	
	$user['WWW'] = $_POST['www'];
	$blog_config['EMAIL'] = $user['EMAIL'] = $_POST['email'];
	
	
	
	if (isset($err)) {
		$GLOBALS['err']=$err;
		return 1;
	}
	
	user_add($user);
	
	$blog_config['BLOGID']=system_generate_id(BLOG_ROOT.$blog_config['WWW'].$blog_config['EMAIL'].$blog_config['AUTHOR'] );	
	config_save($blog_config);
	
	
	return 0;
}

function print_err() {
	global $err;
	if (isset($err)) {
		echo "<p><big>Error!</big> 
		The following errors have been encountered processing the form:</p><ul>";
		foreach ($err as $val) {
			echo "<li>$val</li>";
		}
		echo "</ul>";
	}
}

function create_content() {

	global $fpdb;
	$GLOBALS['fpdb'] =& new FPDB;

	$contents = <<<CONT
	
Welcome to [url=http://flatpress.nowhereland.it]FlatPress[/url] !

This is a sample entry, posted to show you some of the features of [url=http://flatpress.nowhereland.it]FlatPress[/url].

The default way to style and format your content is [b]BBcode[/b] (bulletin board code). BBCode is an easy way to style your posts. Most common codes are allowed. Like [b] for [b]bold[/b] (html: strong), [i] for [i]italics[/i] (html: em), etc.

[quote]
There are also [b]quote[/b] blocks to display your favourite quotations. 
[/quote]

[code]
and 'code' displays your snippets in a monospaced fashion
[/code]

img and url tag have also special options. You can find out more on the [url=http://flatpress.nowhereland.it]FP official website[/url].

We have created some more sample content, to show you some of the FP well hidden functions and gems :) ; you can find two [b]static pages[/b] ready to accept your contents ([url=static.php?page=about]About me[/url]) and links ([url=static.php?page=menu]Menu[/url]): notice that your links will appear on your sidebar as well, this is the magic of the [b]blockparser widget[/b]: see the [url=http://flatpress.nowhereland.it/static.php?page=faq]FAQ[/url] for this and more. 

Follow the [url=http://flatpress.nowhereland.it/]official blog[/url] to keep in touch and [b]read tips and tricks[/b]; and get [b]great themes[/b] at [url=http://fpthemes.nowhereland.it]FPThemes[/url]!

Now you can [url=login.php]Login[/url] to get to the [url=admin.php]Control Panel[/url] and start posting!

Goodbye, we'll hope you'll enjoy your staying :) 

[i][url=http://www.nowhereland.it]NoWhereMan[/url] and the FlatPress Team[/i]
	
CONT;

	$id = entry_save(
	
		array(
			'subject'	=> 'Welcome to FlatPress',
			'content'	=> $contents,
			'author'	=> 'FlatPress Team',
			'version'	=> system_ver() 
		)
	
	);
	
	if ($id) {
		$v = comment_save($id, 
		
			array(
				'name'		=>	'FlatPress Team',
				'url'		=>	'http://flatpress.sf.net',
				'content'	=>	'Welcome to FlatPress',
				'version'	=>	system_ver()
			)
		
		);
	}
	
	if (!static_exists('menu')) {
	
		$v = $v && 
		static_save(		
				array(
					'author'		=>	'FlatPress Team',
					'subject'		=>	'Links',
					'content'		=>	
'[list]
[*][url=index.php]Home[/url]
[*][url=static.php?page=about]About[/url]
[*][url=contact.php]Contact[/url]
[/list]',
					'version'	=>	system_ver()
				),
				'menu'
			);
			
	}
	
	if (!static_exists('about')) {
		
		$v = $v && 
		static_save(
			array(
					'author'		=>	'FlatPress Team',
					'subject'		=>	'About',
					'content'		=>	
					'[[url=admin.php?p=static]click me to edit[/url]]. Put here something about yourself :). ',
					'version'	=>	system_ver()
				),
				'about'
		);
	
	}
	
	return $id && $v;

}



?>
<?php
global $blog_config;
extract($blog_config); 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head><title>Flatpress installer</title>
		<link href="setup/res/setup.css" type="text/css" rel="stylesheet" /></head>
<body>
	<div id="rap">
		<h1 id="header">FlatPress Installer</h1>
		<!--p id="pagesubtitle">FlatPress. Flat. Smooth. Straightforward.</p-->
		</div>

		<div id="main">
		
	
<form class="storycontent" method="post" action="<?php echo BLOG_BASEURL ?>setup.php"> 
<?php

if (file_exists(LOCKFILE)) {
	if (isset($_GET['action']) && $_GET['action']=='stupidquestion') {
?>
<h2>Well...</h2>
<div class="post">

<p>No. :)</p>
<ul>
<li><a href="index.php">Kick me to index</a></li>
</ul>
<?php
	} else {
?>
<h2>Setup has been locked.</h2>
<div class="post">
	
<p>It looks like you already run setup, because we found the lockfile 
<?php echo LOCKFILE; ?>. If you're willing to restart flatpress setup, please
delete this file first.</p>
<p><big>Important!</big> Remember that (even with the lockfile thingy)
retaining the setup/ dir on your server is harmful and could expose you to risks 
such as hack attempts from the very first life-less time-wasting lamer 
seeing your blog.</p>
<p>Our advice is always deleting the setup/ folder once the setup has completed
succesfully. :)</p>
<ul>
<li><a href="index.php">Ok, warp me back to index</a></li>
<li><a href="?action=stupidquestion">Blah, blah, can you start setup, now??</a></li>
</ul>

<?php
	}
}

//------------------------------------------------------------------------------


elseif (empty($_POST)) {

session_destroy();

?>

<h2>Welcome to FlatPress !</h2>
<div class="post">
	
<p>We're very glad you decided to test out our blog. This wizard will guide you
through the process of setting up you're brand new unpacked blog, to start
blogging right NOW!</p>

<p><big>Important!</big>
Please read <strong>ANY</strong> part of this wizard as it will give you important informations
about the configuration. Also, for the blog and the setup to work properly you'll
need your browser to <strong>accept cookies</strong>, and your server to work 
properly with <strong>sessions</strong>.</p>
<p>As a side note, remember this is <em>alpha-quality software</em>, 
so you may found bugs and holes.</p>
<p>You've been told!</p>

<p><strong>Click <em>Finish</em> to start.</strong></p>





<div id="buttonbar"><input type="submit" name="joke" id="joke" value="Next >"/>
<input type="submit" name="start" id="start" value="Finish" /></div>



<?php
} elseif (isset($_POST['joke'])) {
?>
<h2>Welcome to <em>Fart</em>Press :D</h2>
<div class="post">
	
<p>Ouch. I've told you to click <strong>Finish</strong></p>
<p>Sorry for the joke ;)</p>

<div id="buttonbar"><input type="submit" name="start" id="start" value="Next" /></div>



<?php
} elseif (isset($_POST['start'])) {
?>


<h2>Default configuration</h2>
<div class="post">

<p>As a very first step we really need the FP_CONTENT 
directory to be chmodded at 0777 (0766 may be good as well). </p>
<?php
if (!is_writable(FP_CONTENT)) {
?>
<p><big>Error!</big><br />
We don't have enough permissions to write to <strong style="color:red"><?php echo FP_CONTENT ?></strong> 
</p>
<p>Please change the permissions of this directory (via FTP,
web control panels or whatever), to give Read/Write 
access to Owner, Group, and Others, or the entire process will horribly fail :)</p>

<p><strong>Once you think you're done</strong>, click the "Check again" button on this page 
to do another test. </p>


<div id="buttonbar">
<input type="submit" name="start" id="start" value="Check Again"/>
</div>

<?php
} else {

?>

<p><big style="color: green">OK!</big>

<?php
if ($confexists=config_exist() && (!($_POST['start']=='Continue'))) {
?>

</p>
<p><big>WARNING!</big> It looks like you already installed FlatPress.</p>

<p>You can now <b>skip</b> this step, or choose to <b>reset</b> your settings.</p>

<p>If you choose to reset, you will loose your custom settings. This may be needed
sometimes when upgrading to a major version, or if your installation got messed and you
can't figure out how to fix it by hand.</p>

<p>We suggest anyway to <strong>backup your <code>fp-content/</code> directory and in
particular <code>fp-content/config/</code></strong>.</p>

<p><strong>Do you really want your settings (config, plugins, widgets) to be reverted to their
defaults ?</strong> Your entries won't be affected.</p>

<p><big>Yes</big>, please, reset this settings:</p>
<ul>

	<li><p><label><input type="checkbox" checked="checked" name="cache" id="cache" />
		<strong>Cache files</strong>.
		<span style="color:red">It is strongly recommended to delete these files if you 
		are upgrading from an older version.</span> Cached files does not contain personal
		information, they're just meant to speed up FlatPress by keeping frequently accessed
		data together. They will be recreated automatically. The main cache index will be
		backupped.
		 </label> </p>
	</li>


	<li><p><label><input type="checkbox" checked="checked" name="setts" id="setts" />
		<strong>My blog settings</strong>.
		Please reset my blog title, subtitle, email, etc.
		 </label> </p>
	</li>
	
	<li><p><label><input type="checkbox" checked="checked" name="plugins" id="plugins" />
		<strong>My plugin settings</strong>.
		Please enable only the default plugins, delete all the references to the
		new plugins I have installed. My <code>fp-plugins/</code> directory won't be affected.
		</label></p>
		 
	</li>
	
	<li><p><label><input type="checkbox" checked="checked" name="widgets" id="widgets" />
		<strong>My widgets settings</strong>.
		Please enable only the default widgets, delete all the references to the
		new widgets I have installed. Neither my <code>fp-plugins/</code> directory 
		or my blocks will be changed.
		</label></p>
		
	</li>

</ul>

<div id="buttonbar">
<input type="submit" name="start" id="start" value="Continue"/>
<input type="submit" name="newuser" id="newuser" value="Skip"/>
</div>
<?php

} else { 
?>

Writing files to FP_CONTENT:</p>

<?php
$confexists=config_exist();
echo '<ul>';
if (isset($_POST['cache'])){
	if (file_exists(CACHE_DIR.CACHE_FILE)) {
		$backup = FP_CONTENT . 'tmp/' . CACHE_FILE . "." . time();	
		fs_mkdir(FP_CONTENT . 'tmp/', 0777);
		print_done_fail("Creating backup for cache index... (on error you may try 
			to restore this file, just remove the numbers and move it to <code>".CACHE_DIR."</code>)", 
		rename(ABS_PATH . CACHE_DIR . CACHE_FILE, $backup));
	}
	echo "<li>", 
	"Creating cache... (this may take some time)";
	$bool = fs_delete_recursive(CACHE_DIR) && fs_mkdir(CACHE_DIR);
	new entry_indexer;	
	echo ' <strong style="color :' . 
	(($bool)? 'green;">DONE' : 'red;">FAILED') .
	'</strong><br />',
	"</li>\n";
}
if (isset($_POST['setts']) || !$confexists)
	print_done_fail("Copying default global configuration... ", 
		fs_copy(CONFIG_DEFAULT, CONFIG_FILE));
if (isset($_POST['plugins']) || !$confexists)
	print_done_fail("Copying default plugin configuration... ", 
		fs_copy(FP_DEFAULTS. 'plugins.conf.php', 
				CONFIG_DIR . 'plugins.conf.php'));
if (isset($_POST['widgets']) || !$confexists)
	print_done_fail("Copying default widget configuration... ", 
		fs_copy(FP_DEFAULTS. 'widgets.conf.php', 
				CONFIG_DIR . 'widgets.conf.php'));
if (!isset($_POST['cache'])){
print_done_fail("Creating cache dir... ", 
				fs_mkdir(CACHE_DIR));
}

print_done_fail("Creating sample content...", create_content());

echo '</ul>';
?>



<div id="buttonbar"><input type="submit" name="newuser" id="newuser" value="Continue" /></div>


<?php
}
}
} /* USER CREATION */
elseif (isset($_POST['newuser']) ||
			(isset($_POST['create']) && validate())) {
?>

<h2>Create an administrator</h2>
<div class="post">

<?php
	$usr = file_exists(USERS_DIR);
	if ($usr) {
?>
<p><big>WARNING!</big> If this is a reinstallation, choosing an existing
 username will re-create the corresponding user. 
 <strong>This is useful if you forgot your password</strong>.</p>
<?php

/* <p>If you already have a working user, you can <b>skip</b> this step.</p> */

	}
	print_err();
?>

<p><label for="fpuser"><strong>Username</strong></label><br />
<input type="text" class="maxsize" name="fpuser" id="fpuser" 
	value="<?php echo str_replace(' ', '', $blog_config['AUTHOR']); ?>"/></p>
<p><label for="fppwd"><strong>Password</strong></label><br />
<input type="password" class="maxsize" name="fppwd" id="fppwd" /></p>
<p><label for="fppwd2"><strong>Re-type Password</strong></label><br />
<input type="password" class="maxsize" name="fppwd2" id="fppwd2" /></p>
<p><label for="email"><strong>User email</strong></label><br />
<input type="text" class="maxsize" name="email" id="email" 
	value="<?php echo $blog_config['EMAIL']; ?>" /></p>
<p><label for="www"><strong>Home Page</strong>. 
	URL to your home page or to your blog</label><br />
<input type="text" class="maxsize" name="www" id="www" 
	value="<?php echo  BLOG_BASEURL; ?>" /></p>


<div id="buttonbar"><input type="submit" name="create" id="create" value="Create" />
<?php
	if (false && $usr) {
?>
<input type="submit" name="skip" id="skip" value="Skip" />
<?php
	}
?>
</div>
<?php
} elseif (isset($_POST['create']) || isset($_POST['skip'])) {

?>
<h2>Setup is complete</h2>
<div class="post">
	
<?php

	$success = 
	io_write_file(LOCKFILE, 'Setup has been locked');
?>

<p>Now you're really ready to start playing with your new blogging toy</p>

<p><strong>Keep in touch!</strong> FlatPress evolves every day! Have a look at the
<a href="http://flatpress.nowhereland.it/">official blog</a>; post a comment, 
and tell us how to improve it!</p>

<p><strong>Customize!</strong> Take some time to visit the <a href="http://fpthemes.nowhereland.it">theme site</a>
to download new exciting suitcase for your blog!</p>

<p><strong>Need help?</strong> Ask in our <a href="http://spbitalia.altervista.org">forums</a>!</p>

<p>Hope we'll meet soon, now :) Bye!</p>

<p><big>Enjoy!</big></p>

<ul>
	<li><a href="login.php?redirect=admin.php?p=config">Take me to the config panel (login first)</a></li>
	<li><a href="index.php">Warp me to my new home page</a></li>
</ul>

<?php
}
?>

</div>
</form>
</div>
</body>
</html>
